/***********************************************************************
 *                                                                   _
 *       _____  _                           ____  _                 |_|
 *      |  _  |/ \   ____  ____ __ ___     / ___\/ \   __   _  ____  _
 *      | |_| || |  / __ \/ __ \\ '_  \ _ / /    | |___\ \ | |/ __ \| |
 *      |  _  || |__. ___/. ___/| | | ||_|\ \___ |  _  | |_| |. ___/| |
 *      |_/ \_|\___/\____|\____||_| |_|    \____/|_| |_|_____|\____||_| 
 *                                                                      
 *      ================================================================
 *                 More than a coder, More than a designer              
 *      ================================================================
 *
 *
 *      - Document: index.js
 *      - Author: aleen42
 *      - Description: the main entrance for automatically generating repo
 *      			   and return the path
 *      - Create Time: Apr 13th, 2016
 *      - Update Time: Apr 13th, 2016
 *
 *
 **********************************************************************/

/**
 * [Contributions: gh-contributions module]
 * @type {Object}
 */
const Contributions = require("./../node_modules/gh-contributions/lib/contributions");

module.exports =  {
	/**
	 * [clientData: json data generated with gh-contributions]
	 * @type {String}
	 */
	clientData: "{\"coordinates\": [{\"x\": 3,\"y\": 3},{\"x\": 3,\"y\": 4},{\"x\": 3,\"y\": 5},{\"x\": 3,\"y\": 6},{\"x\": 4,\"y\": 2},{\"x\": 4,\"y\": 4},{\"x\": 5,\"y\": 2},{\"x\": 5,\"y\": 4},{\"x\": 6,\"y\": 3},{\"x\": 6,\"y\": 4},{\"x\": 6,\"y\": 5},{\"x\": 6,\"y\": 6},{\"x\": 8,\"y\": 2},{\"x\": 8,\"y\": 3},{\"x\": 8,\"y\": 4},{\"x\": 8,\"y\": 5},{\"x\": 9,\"y\": 6},{\"x\": 10,\"y\": 6},{\"x\": 12,\"y\": 3},{\"x\": 12,\"y\": 4},{\"x\": 12,\"y\": 5},{\"x\": 13,\"y\": 2},{\"x\": 13,\"y\": 4},{\"x\": 13,\"y\": 6},{\"x\": 14,\"y\": 2},{\"x\": 14,\"y\": 4},{\"x\": 14,\"y\": 6},{\"x\": 15,\"y\": 3},{\"x\": 15,\"y\": 4},{\"x\": 15,\"y\": 6},{\"x\": 17,\"y\": 3},{\"x\": 17,\"y\": 4},{\"x\": 17,\"y\": 5},{\"x\": 18,\"y\": 2},{\"x\": 18,\"y\": 4},{\"x\": 18,\"y\": 6},{\"x\": 19,\"y\": 2},{\"x\": 19,\"y\": 4},{\"x\": 19,\"y\": 6},{\"x\": 20,\"y\": 3},{\"x\": 20,\"y\": 4},{\"x\": 20,\"y\": 6},{\"x\": 22,\"y\": 3},{\"x\": 22,\"y\": 4},{\"x\": 22,\"y\": 5},{\"x\": 22,\"y\": 6},{\"x\": 23,\"y\": 2},{\"x\": 24,\"y\": 2},{\"x\": 25,\"y\": 3},{\"x\": 25,\"y\": 4},{\"x\": 25,\"y\": 5},{\"x\": 25,\"y\": 6},{\"x\": 27,\"y\": 2},{\"x\": 27,\"y\": 3},{\"x\": 27,\"y\": 4},{\"x\": 27,\"y\": 5},{\"x\": 28,\"y\": 5},{\"x\": 29,\"y\": 2},{\"x\": 29,\"y\": 3},{\"x\": 29,\"y\": 4},{\"x\": 29,\"y\": 5},{\"x\": 29,\"y\": 6},{\"x\": 30,\"y\": 5},{\"x\": 32,\"y\": 2},{\"x\": 32,\"y\": 6},{\"x\": 33,\"y\": 2},{\"x\": 33,\"y\": 5},{\"x\": 33,\"y\": 6},{\"x\": 34,\"y\": 2},{\"x\": 34,\"y\": 3},{\"x\": 34,\"y\": 4},{\"x\": 34,\"y\": 6},{\"x\": 36,\"y\": 1},{\"x\": 36,\"y\": 2},{\"x\": 37,\"y\": 1},{\"x\": 37,\"y\": 2}],\"commitsPerDay\": 352}",
	run: function () {
		/** Generate repository */
		Contributions(JSON.parse(this.clientData), function (err, repoLink) {
			/** Prepare the path to the repository */
		    repoLink += "/";
		    
		    /** Return the path */
		    console.log(repoLink)
		}, function (progress) {});
	},
	test: function (testCase) {
		var output = Contributions(JSON.parse(testCase), function (err, repoLink) {
			/** Store output info */
			return err;
		}, function (progress) {});

		output = output || 'null';
		return output;
	}
};
